#include "menu.h"
/* mu_do - present a menu, process actions until user SCR_EXIT
 */
void mu_do(pm)
	MENU *pm;
	{
	FIELD *pf;
	static short level = 0;

	if (level == 0)
		scr_open();	/* initialize the terminal state */
	++level;
	FOREVER
		{
		mu_pr(pm);						/* print the menu */
		pf = mu_ask(pm);				/* get a new field ptr */
		if (pf == NULL)
			break;
		else if (pf->val_type == 'm')	/* new field is a menu */
			mu_do(pf->pmenu);
		else /* pf->val_type == 'f' -- new field is a C fn */
			{
			asserts(pf->val_type == 'f', "val_type is 'f'");
			(void)(*pf->pfn)(pm);
			}
		}
	--level;
	if (level == 0)
		{
		scr_curs(scr_lins-1, 0);
		scr_close();	/* restore terminal state */
		}
	}
